## solarus 1.3-maemo1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(SOLARUS)

# the engine
add_subdirectory(src)

# quests
set(quests "zsdx" "zsxd" "debug_quest") # put here your list of quests 

foreach(quest_name ${quests})
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/quests/${quest_name})
    add_subdirectory(quests/${quest_name}/data)
  endif(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/quests/${quest_name})
endforeach(quest_name ${quests})

# tests
add_subdirectory(tests)

=== src/CMakeLists.txt ===
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

find_package(SDL)
find_package(SDL_image)
find_package(SDL_ttf)
find_package(OpenAL)
find_package(VorbisFile)
find_package(ModPlug)
find_package(Lua51)
find_package(PhysFS)

include_directories(
  ${SOLARUS_SOURCE_DIR}/include
  ${SOLARUS_SOURCE_DIR}/include/snes_spc
  ${LUA_INCLUDE_DIR}
)

file(
  GLOB_RECURSE
  source_files
  *.cpp
  ../include/*.h
)

set(main_source_file Main.cc)

add_library(solarus_static
  STATIC
  ${source_files}
)

add_executable(solarus
  ${main_source_file}
)

set_target_properties(solarus_static PROPERTIES COMPILE_FLAGS "-O3 -Wall -Werror")
set_target_properties(solarus PROPERTIES COMPILE_FLAGS "-O3 -Wall -Werror")

if (DEFINED DATAPATH)
  add_definitions(-DDATAPATH=\"${DATAPATH}\")
endif (DEFINED DATAPATH)

target_link_libraries(solarus
  solarus_static
  ${SDL_LIBRARY}
  ${SDLIMAGE_LIBRARY}
  ${SDLTTF_LIBRARY}
  ${OPENAL_LIBRARY}
  ${LUA_LIBRARY}
  ${PHYSFS_LIBRARY}
  ${VORBISFILE_LIBRARY}
  ${MODPLUG_LIBRARY}
)

install(TARGETS	solarus
  RUNTIME DESTINATION bin
)

=== tests/CMakeLists.txt ===
enable_testing()

include_directories(
  ${SOLARUS_SOURCE_DIR}/include
)

# each .cpp file of the 'tests' directory is a test with a main() function
add_definitions(-DSOLARUS_NOMAIN)
file(
  GLOB
  tests_main_files
  *.cpp
)

foreach(test_main_file ${tests_main_files})

  get_filename_component(test_bin_file ${test_main_file} NAME_WE)
  set(test_bin_file ${test_bin_file}.bin)
  add_executable(${test_bin_file} ${test_main_file})
  set(tests_bin_files ${tests_bin_files} ${test_bin_file})

  if(NOT WIN32)
    set_target_properties(${test_bin_file} PROPERTIES COMPILE_FLAGS "-g -ansi -pedantic -Wall -Werror")
  endif(NOT WIN32)

  target_link_libraries(${test_bin_file}
    solarus_static
    ${SDL_LIBRARY}
    ${SDLIMAGE_LIBRARY}
    ${SDLTTF_LIBRARY}
    ${OPENAL_LIBRARY}
    ${VORBISFILE_LIBRARY}
    ${MODPLUG_LIBRARY}
    ${LUA_LIBRARY}
    ${PHYSFS_LIBRARY}
  )

  add_test(${test_main_file} ${EXECUTABLE_OUTPUT_PATH}/${test_bin_file} -no-audio -no-video -datapath=${SOLARUS_SOURCE_DIR}/quests/debug_quest)

endforeach(test_main_file ${test_main_files})

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND}
                  DEPENDS ${tests_bin_files})

=== quests/zsxd/data/CMakeLists.txt ===
set(quest_name "zsxd")

# compile the Lua scripts
file(GLOB lua_source_files 
  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
  maps/*.lua
  items/*.lua
  enemies/*.lua)

set(lua_bin_files "")

MAKE_DIRECTORY("${CMAKE_CURRENT_BINARY_DIR}/maps")
MAKE_DIRECTORY("${CMAKE_CURRENT_BINARY_DIR}/items")
MAKE_DIRECTORY("${CMAKE_CURRENT_BINARY_DIR}/enemies")

# convert to Lua bytecode
foreach(lua_source_file ${lua_source_files})
  add_custom_command(
    OUTPUT ${lua_source_file}c
    MAIN_DEPENDENCY ${lua_source_file}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND luac -o ${CMAKE_CURRENT_BINARY_DIR}/${lua_source_file}c ${lua_source_file})
  set(lua_bin_files ${lua_bin_files} ${lua_source_file}c)
endforeach(lua_source_file ${lua_source_files})

# add lua bytecode to the zip archive
add_custom_command(
  OUTPUT compiled_lua
  DEPENDS ${lua_bin_files}
  COMMAND zip -q data.solarus ${lua_bin_files}
)

# data files list
file(GLOB_RECURSE data_files
  RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
  *.spc *.ogg *.it *.png *.dat *.ttf *.fon)

# add other data to zip archive
add_custom_command(
  OUTPUT data.solarus
  DEPENDS ${data_files}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND zip -q ${CMAKE_CURRENT_BINARY_DIR}/data.solarus ${data_files}
)

add_custom_target(${quest_name}_data
  ALL
  DEPENDS data.solarus compiled_lua
)

# create a script that executes the game with this quest
add_custom_command(
  OUTPUT ${quest_name}
  COMMAND echo '\#!/bin/bash' > ${quest_name}
  COMMAND echo '${CMAKE_INSTALL_PREFIX}/bin/solarus -datapath=${CMAKE_INSTALL_PREFIX}/share/solarus/${quest_name} $*' >> ${quest_name}
)
add_custom_target(${quest_name}_command
  ALL
  DEPENDS ${quest_name}
)

# install the data archive
install(FILES data.solarus
  DESTINATION share/solarus/${quest_name}
)

# install the script
install(PROGRAMS ${quest_name}
  DESTINATION bin
)

=== debian/changelog ===
solarus (1.3-maemo1) unstable; urgency=low
	
  * Backspace for Escape

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Wed, 31 Aug 2011 09:01:31 +0020

=== debian/control ===
Source: solarus
Section: user/games
Priority: optional
Maintainer: Aapo Rantalainen <aapo.rantalainen@gmail.com>
Build-Depends: debhelper (>> 5.0.0), dh-buildinfo, libsdl1.2-dev,  libsdl-image1.2-dev, libsdl-ttf2.0-dev, lua5.1, liblua5.1-0-dev, libmodplug-dev, libphysfs-dev, libvorbis-dev, libopenal-dev, zip, cmake
Standards-Version: 3.7.2
Homepage: http://www.zelda-solarus.com/jeu-zsxd-download&lang=en
XSBC-Bugtracker: mailto:aapo.rantalainen@gmail.com

Package: solarus
Architecture: any
Depends: ${shlibs:Depends}
Description: A cross-platform 2D Zelda-game
 Zelda Mystery of Solarus XD is a parodic minigame realized with
 the engine of Zelda: Mystery of Solarus DX.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess. 

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CPPFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CPPFLAGS += -O0
else
	CPPFLAGS += -O3
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CPPFLAGS += -g -O0 -DDEBUG
else
	CPPFLAGS += -DNDEBUG
endif

#maemo
ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
	CPPFLAGS += -fomit-frame-pointer
	#internal compiler error under maemo scratchbox
        #CPPFLAGS += -frename-registers
	CPPFLAGS += -ffast-math
	#omap2
#	CPPFLAGS += -mcpu=arm1136j-s -mfpu=vfp -mfloat-abi=softfp 
	#omap3
#	CPPFLAGS += -mcpu=cortex-a8 -mfpu=vfp3 -mfloat-abi=softfp 
	CPPFLAGS += -mcpu=cortex-a8 -mfpu=neon -mfloat-abi=softfp
	CPPFLAGS += -ftree-vectorize -fsingle-precision-constant
endif



config.status: configure
	dh_testdir
	# Add here commands to configure the package.

configure:

build: build-stamp
build-stamp: config.status
	dh_testdir

	# Add here commands to compile the package.
	cmake -D CMAKE_INSTALL_PREFIX=/opt/solarus -D DATAPATH=/opt/solarus .
	make
	touch build-stamp

clean: config.status
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	#make clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/<packagename>
	#$(MAKE) DESTDIR=`pwd`/debian/`dh_listpackages` install
	#!/bin/sh
	CURDIR=$1

	#binary
	install -d  ${CURDIR}/debian/solarus/opt/solarus/
	install ${CURDIR}/src/solarus ${CURDIR}/debian/solarus/opt/solarus/

	#data
	install ${CURDIR}/quests/zsxd/data/data.solarus ${CURDIR}/debian/solarus/opt/solarus/

	#icon
	#install -d  ${CURDIR}/debian/solarus/usr/share/pixmaps 
	#install ${CURDIR}/icon.png  ${CURDIR}/debian/solarus/usr/share/pixmaps/solarus.png

	#menu
	install -d ${CURDIR}/debian/solarus/usr/share/applications/hildon
	install ${CURDIR}/debian/solarus.desktop ${CURDIR}/debian/solarus/usr/share/applications/hildon


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installchangelogs
#	dh_installdocs
#	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installwm
#	dh_installudev
#	dh_undocumented
#	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
